Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4541)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4542)
@@ -1,20 +1,19 @@
 !> @file bulk_cloud_model_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -25,87 +24,90 @@
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+! 4535 2020-05-15 12:07:23Z raasch
 ! bugfix for restart data format query
-! 
+!
 ! 4533 2020-05-14 14:46:46Z schwenkel
 ! Reformat intrinsic function
-! 
+!
 ! 4532 2020-05-14 13:41:35Z schwenkel
 ! Calculate mean droplet radius assuming gamma distibution for condensation
-! 
+!
 ! 4521 2020-05-06 11:39:49Z schwenkel
 ! Rename variable
-! 
+!
 ! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO for reading local arrays
-! 
+!
 ! 4506 2020-04-21 10:57:45Z schwenkel
 ! Use correct magnus formula for liquid water temperature
-! 
+!
 ! 4502 2020-04-17 16:14:16Z schwenkel
 ! Implementation of ice microphysics
-! 
+!
 ! 4495 2020-04-13 20:11:20Z raasch
 ! restart data handling with MPI-IO added
-! 
+!
 ! 4457 2020-03-11 14:20:43Z raasch
 ! use statement for exchange horiz added
-! 
+!
 ! 4418 2020-02-21 09:41:13Z raasch
 ! bugfix for raindrop number adjustment
-! 
+!
 ! 4370 2020-01-10 14:00:44Z raasch
 ! vector directives added to force vectorization on Intel19 compiler
-! 
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
 ! topography information used in wall_flags_static_0
-! 
+!
 ! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
-! 
+!
 ! 4289 2019-11-05 14:33:41Z knoop
 ! Removed parameters precipitation and precipitation_amount_interval from namelist
-! 
+!
 ! 4268 2019-10-17 11:29:38Z schwenkel
 ! Introducing bcm_boundary_conditions
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4168 2019-08-16 13:50:17Z suehring
 ! Replace function get_topography_top_index by topo_top_ind
-! 
+!
 ! 4110 2019-07-22 17:05:21Z suehring
-! Pass integer flag array as well as boundary flags to WS scalar advection 
+! Pass integer flag array as well as boundary flags to WS scalar advection
 ! routine
-! 
+!
 ! 4109 2019-07-22 17:00:34Z suehring
 ! Added microphyics scheme 'morrision_no_rain'
-! 
+!
 ! 3931 2019-04-24 16:34:28Z schwenkel
 ! Added bcm_exchange_horiz which is called after non_transport_physics
-! 
+!
 ! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction 
+! Changes related to global restructuring of location messages and introduction
 ! of additional debug messages
-! 
+!
 ! 3874 2019-04-08 16:53:48Z knoop
 ! Implemented non_transport_physics module interfaces
-! 
+!
 ! 3870 2019-04-08 13:44:34Z knoop
 ! Moving prognostic equations of bcm into bulk_cloud_model_mod
-! 
+!
 ! 3869 2019-04-08 11:54:20Z knoop
 ! moving the furniture around ;-)
-! 
+!
 ! 3786 2019-03-06 16:58:03Z raasch
 ! unsed variables removed
-! 
+!
 ! 3767 2019-02-27 08:18:02Z raasch
 ! unused variable for file index removed from rrd-subroutines parameter list
-! 
+!
 ! 3724 2019-02-06 16:28:23Z kanani
 ! Correct double-used log_point_s unit
-! 
+!
 ! 3700 2019-01-26 17:03:42Z knoop
 ! nopointer option removed
@@ -116,99 +118,98 @@
 ! ------------
 !> Calculate bulk cloud microphysics.
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  MODULE bulk_cloud_model_mod
 
 
-    USE advec_s_bc_mod,                                                        &
+    USE advec_s_bc_mod,                                                                            &
         ONLY:  advec_s_bc
 
-    USE advec_s_pw_mod,                                                        &
+    USE advec_s_pw_mod,                                                                            &
         ONLY:  advec_s_pw
 
-    USE advec_s_up_mod,                                                        &
+    USE advec_s_up_mod,                                                                            &
         ONLY:  advec_s_up
 
-    USE advec_ws,                                                              &
+    USE advec_ws,                                                                                  &
         ONLY:  advec_s_ws
 
-    USE arrays_3d,                                                             &
-        ONLY:  ddzu, diss, dzu, dzw, hyp, hyrho,                               &
-               nc, nc_1, nc_2, nc_3, nc_p, nr, nr_1, nr_2, nr_3, nr_p,         &
-               precipitation_amount, prr, pt, d_exner, pt_init, q, ql, ql_1,   &
-               qc, qc_1, qc_2, qc_3, qc_p, qr, qr_1, qr_2, qr_3, qr_p,         &
-               exner, zu, tnc_m, tnr_m, tqc_m, tqr_m, tend, rdf_sc,            &
-               flux_l_qc, flux_l_qr, flux_l_nc, flux_l_nr,                     &
-               flux_s_qc, flux_s_qr, flux_s_nc, flux_s_nr,                     &
-               diss_l_qc, diss_l_qr, diss_l_nc, diss_l_nr,                     &
-               diss_s_qc, diss_s_qr, diss_s_nc, diss_s_nr,                     &
-               ni, ni_1, ni_2, ni_3, ni_p, tni_m,                              &
-               qi, qi_1, qi_2, qi_3, qi_p, tqi_m,                              &
-               flux_l_qi, flux_l_ni, flux_s_qi, flux_s_ni,                     &
-               diss_l_qi, diss_l_ni, diss_s_qi, diss_s_ni
-
-
-    USE averaging,                                                             &
-        ONLY:  nc_av, nr_av, prr_av, qc_av, ql_av, qr_av, ni_av, qi_av
-
-    USE basic_constants_and_equations_mod,                                     &
-        ONLY:  c_p, g, lv_d_cp, lv_d_rd, l_v, magnus, magnus_ice, magnus_tl,   &
-               molecular_weight_of_solute,                                     &
-               molecular_weight_of_water, pi, rho_l, rho_s, r_d, r_v, vanthoff,&
-               exner_function, exner_function_invers, ideal_gas_law_rho,       &
-               ideal_gas_law_rho_pt, barometric_formula, rd_d_rv, l_s,         &
-               ls_d_cp
-
-    USE control_parameters,                                                    &
-        ONLY:  bc_dirichlet_l,                                                 &
-               bc_dirichlet_n,                                                 &
-               bc_dirichlet_r,                                                 &
-               bc_dirichlet_s,                                                 &
-               bc_radiation_l,                                                 &
-               bc_radiation_n,                                                 &
-               bc_radiation_r,                                                 &
-               bc_radiation_s,                                                 &
-               debug_output,                                                   &
-               dt_3d, dt_do2d_xy, intermediate_timestep_count,                 &
-               intermediate_timestep_count_max, large_scale_forcing,           &
-               lsf_surf, pt_surface, restart_data_format_output, rho_surface,  &
-               surface_pressure,                                               &
-               time_do2d_xy, message_string, initializing_actions,             &
-               ws_scheme_sca, scalar_advec, timestep_scheme, tsc,              &
-               loop_optimization, simulated_time
-
-    USE cpulog,                                                                &
+    USE arrays_3d,                                                                                 &
+        ONLY:  diss_s_qc, diss_s_qr, diss_s_nc, diss_s_nr,                                         &
+               diss_l_qc, diss_l_qr, diss_l_nc, diss_l_nr,                                         &
+               diss_l_qi, diss_l_ni, diss_s_qi, diss_s_ni,                                         &
+               ddzu, diss, dzu, dzw, hyp, hyrho,                                                   &
+               exner, zu, tnc_m, tnr_m, tqc_m, tqr_m, tend, rdf_sc,                                &
+               flux_l_qc, flux_l_qr, flux_l_nc, flux_l_nr,                                         &
+               flux_l_qi, flux_l_ni, flux_s_qi, flux_s_ni,                                         &
+               flux_s_qc, flux_s_qr, flux_s_nc, flux_s_nr,                                         &
+               nc, nc_1, nc_2, nc_3, nc_p, nr, nr_1, nr_2, nr_3, nr_p,                             &
+               ni, ni_1, ni_2, ni_3, ni_p, tni_m,                                                  &
+               precipitation_amount, prr, pt, d_exner, pt_init, q, ql, ql_1,                       &
+               qc, qc_1, qc_2, qc_3, qc_p, qr, qr_1, qr_2, qr_3, qr_p,                             &
+               qi, qi_1, qi_2, qi_3, qi_p, tqi_m
+
+
+    USE averaging,                                                                                 &
+        ONLY:  nc_av,ni_av, nr_av, prr_av, qc_av, ql_av, qi_av, qr_av
+
+    USE basic_constants_and_equations_mod,                                                         &
+        ONLY:  c_p, g, lv_d_cp, lv_d_rd, l_v, magnus, magnus_ice, magnus_tl,                       &
+               exner_function, exner_function_invers, ideal_gas_law_rho,                           &
+               ideal_gas_law_rho_pt, barometric_formula, rd_d_rv, l_s,                             &
+               ls_d_cp,                                                                            &
+               molecular_weight_of_solute,                                                         &
+               molecular_weight_of_water, pi, rho_l, rho_s, r_d, r_v, vanthoff
+
+    USE control_parameters,                                                                        &
+        ONLY:  bc_dirichlet_l,                                                                     &
+               bc_dirichlet_n,                                                                     &
+               bc_dirichlet_r,                                                                     &
+               bc_dirichlet_s,                                                                     &
+               bc_radiation_l,                                                                     &
+               bc_radiation_n,                                                                     &
+               bc_radiation_r,                                                                     &
+               bc_radiation_s,                                                                     &
+               debug_output,                                                                       &
+               dt_3d, dt_do2d_xy, intermediate_timestep_count,                                     &
+               intermediate_timestep_count_max, large_scale_forcing,                               &
+               loop_optimization, simulated_time,                                                  &
+               lsf_surf, pt_surface, restart_data_format_output, rho_surface,                      &
+               surface_pressure,                                                                   &
+               time_do2d_xy, message_string, initializing_actions,                                 &
+               ws_scheme_sca, scalar_advec, timestep_scheme, tsc
+
+    USE cpulog,                                                                                    &
         ONLY:  cpu_log, log_point, log_point_s
 
-    USE diffusion_s_mod,                                                       &
+    USE diffusion_s_mod,                                                                           &
         ONLY:  diffusion_s
 
-    USE grid_variables,                                                        &
+    USE grid_variables,                                                                            &
         ONLY:  dx, dy
 
-    USE indices,                                                               &
-        ONLY:  advc_flags_s,                                                   &
-               nbgp, nxl, nxlg, nxr, nxrg, nys, nysg, nyn, nyng, nzb, nzt,     &
-               topo_top_ind,                                                   &
+    USE indices,                                                                                   &
+        ONLY:  advc_flags_s,                                                                       &
+               nbgp, nxl, nxlg, nxr, nxrg, nys, nysg, nyn, nyng, nzb, nzt,                         &
+               topo_top_ind,                                                                       &
                wall_flags_total_0
 
     USE kinds
 
-    USE pegrid,                                                                &
+    USE pegrid,                                                                                    &
         ONLY:  threads_per_task
 
-    USE restart_data_mpi_io_mod,                                               &
+    USE restart_data_mpi_io_mod,                                                                   &
         ONLY:  rd_mpi_io_check_array, rrd_mpi_io, wrd_mpi_io
 
-    USE statistics,                                                            &
-        ONLY:  weight_pres, weight_substep, sums_wsncs_ws_l, sums_wsnrs_ws_l,  &
-               sums_wsqcs_ws_l, sums_wsqrs_ws_l,                               &
-               sums_wsqis_ws_l, sums_wsnis_ws_l
-
-    USE surface_mod,                                                           &
-        ONLY :  bc_h,                                                          &
-                surf_bulk_cloud_model,                                         &
-                surf_microphysics_morrison, surf_microphysics_seifert,         &
-                surf_microphysics_ice_phase,                               &
-                surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,    &
+    USE statistics,                                                                                &
+        ONLY:  sums_wsncs_ws_l, sums_wsnis_ws_l, sums_wsnrs_ws_l, sums_wsqcs_ws_l, sums_wsqis_ws_l,&
+               sums_wsqrs_ws_l, weight_pres, weight_substep
+
+    USE surface_mod,                                                                               &
+        ONLY :  bc_h,                                                                              &
+                surf_bulk_cloud_model,                                                             &
+                surf_microphysics_morrison, surf_microphysics_seifert,                             &
+                surf_microphysics_ice_phase,                                                       &
+                surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,                        &
                 surf_usm_v
 
@@ -218,86 +219,84 @@
     CHARACTER (LEN=20)   ::  cloud_scheme = 'saturation_adjust'           !< namelist parameter
 
-    LOGICAL ::  aerosol_nacl =.TRUE.                             !< nacl aerosol for bulk scheme
-    LOGICAL ::  aerosol_c3h4o4 =.FALSE.                          !< malonic acid aerosol for bulk scheme
-    LOGICAL ::  aerosol_nh4no3 =.FALSE.                          !< malonic acid aerosol for bulk scheme
-
-    LOGICAL ::  bulk_cloud_model = .FALSE.                       !< namelist parameter
-
-    LOGICAL ::  cloud_water_sedimentation = .FALSE.       !< cloud water sedimentation
-    LOGICAL ::  curvature_solution_effects_bulk = .FALSE. !< flag for considering koehler theory
-    LOGICAL ::  ice_crystal_sedimentation = .FALSE.        !< flag for ice crystal sedimentation
-    LOGICAL ::  limiter_sedimentation = .TRUE.            !< sedimentation limiter
-    LOGICAL ::  collision_turbulence = .FALSE.            !< turbulence effects
-    LOGICAL ::  ventilation_effect = .TRUE.               !< ventilation effect
-
-    LOGICAL ::  call_microphysics_at_all_substeps = .FALSE.      !< namelist parameter
-    LOGICAL ::  microphysics_ice_phase = .FALSE.              !< use ice microphysics scheme
-    LOGICAL ::  microphysics_sat_adjust = .FALSE.                !< use saturation adjust bulk scheme?
-    LOGICAL ::  microphysics_kessler = .FALSE.                   !< use kessler bulk scheme?
-    LOGICAL ::  microphysics_morrison = .FALSE.                  !< use 2-moment Morrison (add. prog. eq. for nc and qc)
-    LOGICAL ::  microphysics_seifert = .FALSE.                   !< use 2-moment Seifert and Beheng scheme
-    LOGICAL ::  microphysics_morrison_no_rain = .FALSE.          !< use 2-moment Morrison
-    LOGICAL ::  precipitation = .FALSE.                          !< namelist parameter
-
-    REAL(wp) ::  precipitation_amount_interval = 9999999.9_wp    !< namelist parameter
-
-    REAL(wp) ::  a_1 = 8.69E-4_wp          !< coef. in turb. parametrization (cm-2 s3)
-    REAL(wp) ::  a_2 = -7.38E-5_wp         !< coef. in turb. parametrization (cm-2 s3)
-    REAL(wp) ::  a_3 = -1.40E-2_wp         !< coef. in turb. parametrization
-    REAL(wp) ::  a_term = 9.65_wp          !< coef. for terminal velocity (m s-1)
-    REAL(wp) ::  a_vent = 0.78_wp          !< coef. for ventilation effect
-    REAL(wp) ::  b_1 = 11.45E-6_wp         !< coef. in turb. parametrization (m)
-    REAL(wp) ::  b_2 = 9.68E-6_wp          !< coef. in turb. parametrization (m)
-    REAL(wp) ::  b_3 = 0.62_wp             !< coef. in turb. parametrization
-    REAL(wp) ::  b_term = 9.8_wp           !< coef. for terminal velocity (m s-1)
-    REAL(wp) ::  b_vent = 0.308_wp         !< coef. for ventilation effect
-    REAL(wp) ::  beta_cc = 3.09E-4_wp      !< coef. in turb. parametrization (cm-2 s3)
-    REAL(wp) ::  c_1 = 4.82E-6_wp          !< coef. in turb. parametrization (m)
-    REAL(wp) ::  c_2 = 4.8E-6_wp           !< coef. in turb. parametrization (m)
-    REAL(wp) ::  c_3 = 0.76_wp             !< coef. in turb. parametrization
-    REAL(wp) ::  c_const = 0.93_wp         !< const. in Taylor-microscale Reynolds number
-    REAL(wp) ::  c_evap = 0.7_wp           !< constant in evaporation
-    REAL(wp) ::  c_term = 600.0_wp         !< coef. for terminal velocity (m-1)
-    REAL(wp) ::  diff_coeff_l = 0.23E-4_wp  !< diffusivity of water vapor (m2 s-1)
-    REAL(wp) ::  eps_sb = 1.0E-10_wp       !< threshold in two-moments scheme
-    REAL(wp) ::  eps_mr = 0.0_wp           !< threshold for morrison scheme
-    REAL(wp) ::  k_cc = 9.44E09_wp         !< const. cloud-cloud kernel (m3 kg-2 s-1)
-    REAL(wp) ::  k_cr0 = 4.33_wp           !< const. cloud-rain kernel (m3 kg-1 s-1)
-    REAL(wp) ::  k_rr = 7.12_wp            !< const. rain-rain kernel (m3 kg-1 s-1)
-    REAL(wp) ::  k_br = 1000.0_wp          !< const. in breakup parametrization (m-1)
-    REAL(wp) ::  k_st = 1.2E8_wp           !< const. in drizzle parametrization (m-1 s-1)
-    REAL(wp) ::  kin_vis_air = 1.4086E-5_wp  !< kin. viscosity of air (m2 s-1)
-    REAL(wp) ::  prec_time_const = 0.001_wp  !< coef. in Kessler scheme (s-1)
-    REAL(wp) ::  ql_crit = 0.0005_wp       !< coef. in Kessler scheme (kg kg-1)
-    REAL(wp) ::  schmidt_p_1d3=0.8921121_wp  !< Schmidt number**0.33333, 0.71**0.33333
-    REAL(wp) ::  sigma_gc = 1.3_wp         !< geometric standard deviation cloud droplets
-    REAL(wp) ::  thermal_conductivity_l = 2.43E-2_wp  !< therm. cond. air (J m-1 s-1 K-1)
-    REAL(wp) ::  w_precipitation = 9.65_wp  !< maximum terminal velocity (m s-1)
-    REAL(wp) ::  x0 = 2.6E-10_wp           !< separating drop mass (kg)
-    REAL(wp) ::  ximin = 4.42E-14_wp       !< minimum mass of ice crystal (kg) (D~10Âµm)
-    REAL(wp) ::  xcmin = 4.18E-15_wp       !< minimum cloud drop size (kg) (~ 1Âµm)
-    REAL(wp) ::  xrmin = 2.6E-10_wp        !< minimum rain drop size (kg)
-    REAL(wp) ::  xrmax = 5.0E-6_wp         !< maximum rain drop site (kg)
-
+    LOGICAL ::  aerosol_nacl =.TRUE.                         !< nacl aerosol for bulk scheme
+    LOGICAL ::  aerosol_c3h4o4 =.FALSE.                      !< malonic acid aerosol for bulk scheme
+    LOGICAL ::  aerosol_nh4no3 =.FALSE.                      !< malonic acid aerosol for bulk scheme
+    LOGICAL ::  bulk_cloud_model = .FALSE.                   !< namelist parameter
+    LOGICAL ::  call_microphysics_at_all_substeps = .FALSE.  !< namelist parameter
+    LOGICAL ::  cloud_water_sedimentation = .FALSE.          !< cloud water sedimentation
+    LOGICAL ::  collision_turbulence = .FALSE.               !< turbulence effects
+    LOGICAL ::  curvature_solution_effects_bulk = .FALSE.    !< flag for considering koehler theory
+    LOGICAL ::  ice_crystal_sedimentation = .FALSE.          !< flag for ice crystal sedimentation
+    LOGICAL ::  limiter_sedimentation = .TRUE.               !< sedimentation limiter
+    LOGICAL ::  microphysics_ice_phase = .FALSE.             !< use ice microphysics scheme
+    LOGICAL ::  microphysics_kessler = .FALSE.               !< use kessler bulk scheme?
+    LOGICAL ::  microphysics_morrison = .FALSE.              !< use 2-moment Morrison
+                                                             !< (add. prog. eq. for nc and qc)
+    LOGICAL ::  microphysics_morrison_no_rain = .FALSE.      !< use 2-moment Morrison
+    LOGICAL ::  microphysics_sat_adjust = .FALSE.            !< use saturation adjust bulk scheme?
+    LOGICAL ::  microphysics_seifert = .FALSE.               !< use 2-moment Seifert and Beheng
+                                                             !< scheme
+    LOGICAL ::  precipitation = .FALSE.                      !< namelist parameter
+    LOGICAL ::  ventilation_effect = .TRUE.                  !< ventilation effect
+
+
+    REAL(wp) ::  a_1 = 8.69E-4_wp                !< coef. in turb. parametrization    (cm-2 s3)
+    REAL(wp) ::  a_2 = -7.38E-5_wp               !< coef. in turb. parametrization    (cm-2 s3)
+    REAL(wp) ::  a_3 = -1.40E-2_wp               !< coef. in turb. parametrization
+    REAL(wp) ::  a_term = 9.65_wp                !< coef. for terminal velocity       (m s-1)
+    REAL(wp) ::  a_vent = 0.78_wp                !< coef. for ventilation effect
+    REAL(wp) ::  b_1 = 11.45E-6_wp               !< coef. in turb. parametrization    (m)
+    REAL(wp) ::  b_2 = 9.68E-6_wp                !< coef. in turb. parametrization    (m)
+    REAL(wp) ::  b_3 = 0.62_wp                   !< coef. in turb. parametrization
+    REAL(wp) ::  b_term = 9.8_wp                 !< coef. for terminal velocity       (m s-1)
+    REAL(wp) ::  b_vent = 0.308_wp               !< coef. for ventilation effect
+    REAL(wp) ::  beta_cc = 3.09E-4_wp            !< coef. in turb. parametrization    (cm-2 s3)
+    REAL(wp) ::  c_1 = 4.82E-6_wp                !< coef. in turb. parametrization    (m)
+    REAL(wp) ::  c_2 = 4.8E-6_wp                 !< coef. in turb. parametrization    (m)
+    REAL(wp) ::  c_3 = 0.76_wp                   !< coef. in turb. parametrization
+    REAL(wp) ::  c_const = 0.93_wp               !< const. in Taylor-microscale Reynolds number
+    REAL(wp) ::  c_evap = 0.7_wp                 !< constant in evaporation
     REAL(wp) ::  c_sedimentation = 2.0_wp        !< Courant number of sedimentation process
+    REAL(wp) ::  c_term = 600.0_wp               !< coef. for terminal velocity       (m-1)
+    REAL(wp) ::  diff_coeff_l = 0.23E-4_wp       !< diffusivity of water vapor        (m2 s-1)
     REAL(wp) ::  dpirho_l                        !< 6.0 / ( pi * rho_l )
     REAL(wp) ::  dry_aerosol_radius = 0.05E-6_wp !< dry aerosol radius
     REAL(wp) ::  dt_micro                        !< microphysics time step
+    REAL(wp) ::  eps_sb = 1.0E-10_wp             !< threshold in two-moments scheme
+    REAL(wp) ::  dt_precipitation = 100.0_wp     !< timestep precipitation (s)
+    REAL(wp) ::  e_s                             !< saturation water vapor pressure
+    REAL(wp) ::  e_si                            !< saturation water vapor pressure over ice
+    REAL(wp) ::  eps_mr = 0.0_wp                 !< threshold for morrison scheme
     REAL(wp) ::  in_init = 1000.0_wp             !< initial number of potential ice nucleii
-    REAL(wp) ::  sigma_bulk = 2.0_wp             !< width of aerosol spectrum
+    REAL(wp) ::  k_cc = 9.44E09_wp               !< const. cloud-cloud kernel         (m3 kg-2 s-1)
+    REAL(wp) ::  k_cr0 = 4.33_wp                 !< const. cloud-rain kernel          (m3 kg-1 s-1)
+    REAL(wp) ::  k_rr = 7.12_wp                  !< const. rain-rain kernel           (m3 kg-1 s-1)
+    REAL(wp) ::  k_br = 1000.0_wp                !< const. in breakup parametrization (m-1)
+    REAL(wp) ::  k_st = 1.2E8_wp                 !< const. in drizzle parametrization (m-1 s-1)
+    REAL(wp) ::  kin_vis_air = 1.4086E-5_wp      !< kin. viscosity of air             (m2 s-1)
     REAL(wp) ::  na_init = 100.0E6_wp            !< Total particle/aerosol concentration (cm-3)
     REAL(wp) ::  nc_const = 70.0E6_wp            !< cloud droplet concentration
-    REAL(wp) ::  dt_precipitation = 100.0_wp     !< timestep precipitation (s)
+    REAL(wp) ::  pirho_l                         !< pi * rho_l / 6.0
+    REAL(wp) ::  prec_time_const = 0.001_wp      !< coef. in Kessler scheme           (s-1)
+    REAL(wp) ::  precipitation_amount_interval = 9999999.9_wp     !< namelist parameter
+    REAL(wp) ::  ql_crit = 0.0005_wp             !< coef. in Kessler scheme           (kg kg-1)
+    REAL(wp) ::  q_s                             !< saturation mixing ratio
+    REAL(wp) ::  q_si                            !< saturation mixing ratio over ice
+    REAL(wp) ::  sat                             !< supersaturation
+    REAL(wp) ::  sat_ice                         !< supersaturation over ice
+    REAL(wp) ::  start_ice_microphysics = 0.0_wp !< time from which on ice microhysics are executed
     REAL(wp) ::  sed_qc_const                    !< const. for sedimentation of cloud water
-    REAL(wp) ::  pirho_l                         !< pi * rho_l / 6.0
-    REAL(wp) ::  start_ice_microphysics = 0.0_wp !< time from which on ice microhysics are executed
-
-    REAL(wp) ::  e_s     !< saturation water vapor pressure
-    REAL(wp) ::  e_si    !< saturation water vapor pressure over ice
-    REAL(wp) ::  q_s     !< saturation mixing ratio
-    REAL(wp) ::  q_si    !< saturation mixing ratio over ice
-    REAL(wp) ::  sat     !< supersaturation
-    REAL(wp) ::  sat_ice !< supersaturation over ice
-    REAL(wp) ::  t_l     !< liquid-(ice) water temperature
+    REAL(wp) ::  schmidt_p_1d3=0.8921121_wp      !< Schmidt number**0.33333, 0.71**0.33333
+    REAL(wp) ::  sigma_bulk = 2.0_wp             !< width of aerosol spectrum
+    REAL(wp) ::  sigma_gc = 1.3_wp               !< geometric standard deviation cloud droplets
+    REAL(wp) ::  t_l                             !< liquid-(ice) water temperature
+    REAL(wp) ::  thermal_conductivity_l = 2.43E-2_wp  !< therm. cond. air         (J m-1 s-1 K-1)
+    REAL(wp) ::  w_precipitation = 9.65_wp       !< maximum terminal velocity         (m s-1)
+    REAL(wp) ::  x0 = 2.6E-10_wp                 !< separating drop mass              (kg)
+    REAL(wp) ::  ximin = 4.42E-14_wp             !< minimum mass of ice crystal       (kg) (D~10Âµm)
+    REAL(wp) ::  xcmin = 4.18E-15_wp             !< minimum cloud drop size           (kg) (~ 1Âµm)
+    REAL(wp) ::  xrmin = 2.6E-10_wp              !< minimum rain drop size            (kg)
+    REAL(wp) ::  xrmax = 5.0E-6_wp               !< maximum rain drop site            (kg)
+
 
     SAVE
